/*+M*************************************************************************
 * Promise SATAII S150 SX8 device driver for LINUX.
 *
 * Copyright (c) 2001-2004  Promise Technology, Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * --------------------------------------------------------------------------  
 * Copyright (c) 1999-2004 Promise Technology, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer,
 *    without modification, immediately at the beginning of the file.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * Where this Software is combined with software released under the terms of 
 * the GNU Public License ("GPL") and the terms of the GPL would require the 
 * combined work to also be released under the terms of the GPL, the terms
 * and conditions of this License will apply in addition to those of the
 * GPL with the exception of any terms or conditions of this License that
 * conflict with, or are expressly prohibited by, the GPL.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *-M************************************************************************
 */

/**************************************************************************
 * File: tools.h       Driver Declaraitons for cml.c. smbus.c
 **************************************************************************/

#if !defined(__TOOLS_H_)
#define	__TOOLS_H_

#ifndef bit
#define bit(x) (1<<x)
#endif

#ifndef CELSIUS2FAHRENHEIT
#define CELSIUS2FAHRENHEIT(f)	(((f * 9) / 5) + 32)
#endif

#ifndef FAHRENHEIT2CELSIUS
#define FAHRENHEIT2CELSIUS(c)	((c - 32) * 5 / 9)
#endif


unsigned char cml_in8(unsigned char *Start, unsigned int Offset);
void cml_out8(unsigned char *Start, unsigned int Offset, unsigned char Value);
U16 cml_in16(unsigned char *Start, unsigned int Offset);
void cml_out16(unsigned char *Start, unsigned int Offset, unsigned short Value);
U32 cml_in32(unsigned char *Start, unsigned int Offset);
void cml_out32(unsigned char *Start, unsigned int Offset, unsigned int Value);

int cml_checkchantype(int cardno, int chan, unsigned char type);
int cml_check_raidfeature(int cardno, unsigned char type);
int cml_readverifystart(int cardno, unsigned char chan);
int cml_readverifyend(int cardno, unsigned char chan);

#endif
